package org.codehaus.mojo.keytool;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on keytool-maven-plugin.<br/> Call <pre>  mvn keytool:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Mon Jan 30 14:11:01 CET 2012
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.9)
 * @goal help
 * @requiresProject false
 * @threadSafe
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.codehaus.mojo:keytool-maven-plugin:1.1", 0 );
        append( sb, "", 0 );

        append( sb, "Keytool: Maven Plugin", 0 );
        append( sb, "A plugin that wraps the keytool program bundled with Sun\'s Java SDK. Allows to manipulate keystores.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 5 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "clean".equals( goal ) )
        {
            append( sb, "keytool:clean", 0 );
            append( sb, "A Mojo that deletes a generated keystore file.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "keystore", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${keystore}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory (Default: ${basedir})", 2 );
                append( sb, "Where to execute the keytool command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${keytool.workingdir}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "export".equals( goal ) )
        {
            append( sb, "keytool:export", 0 );
            append( sb, "Reads (from the keystore) the certificate associated with alias, and stores it in the file cert_file. Implemented as a wrapper around the SDK keytool -export command.\n-export\u00a0\u00a0\u00a0[-v]\u00a0[-protected]\n[-alias\u00a0<alias>]\n[-file\u00a0<file>]\n[-storetype\u00a0<storetype>]\n[-keystore\u00a0<keystore>]\n[-storepass\u00a0<storepass>]\nSee keystore documentation.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "alias", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${alias}", 3 );
                append( sb, "", 0 );

                append( sb, "arguments", 2 );
                append( sb, "List of additional arguments to append to the keytool command line.", 3 );
                append( sb, "Expression: ${keytool.arguments}", 3 );
                append( sb, "", 0 );

                append( sb, "file", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${file}", 3 );
                append( sb, "", 0 );

                append( sb, "keystore", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${keystore}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "storepass", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${storepass}", 3 );
                append( sb, "", 0 );

                append( sb, "storetype", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${storetype}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Enable verbose. See options.", 3 );
                append( sb, "Expression: ${verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory (Default: ${basedir})", 2 );
                append( sb, "Where to execute the keytool command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${keytool.workingdir}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "genkey".equals( goal ) )
        {
            append( sb, "keytool:genkey", 0 );
            append( sb, "Generates a keystore. Implemented as a wrapper around the SDK keytool -genkey command.\n-genkey\u00a0\u00a0\u00a0[-v]\u00a0[-protected]\n[-alias\u00a0<alias>]\n[-keyalg\u00a0<keyalg>]\u00a0[-keysize\u00a0<keysize>]\n[-sigalg\u00a0<sigalg>]\u00a0[-dname\u00a0<dname>]\n[-validity\u00a0<valDays>]\u00a0[-keypass\u00a0<keypass>]\n[-keystore\u00a0<keystore>]\u00a0[-storepass\u00a0<storepass>]\n[-storetype\u00a0<storetype>]\u00a0[-providerName\u00a0<name>]\n[-providerClass\u00a0<provider_class_name>\u00a0[-providerArg\u00a0<arg>]]\u00a0...\nSee keystore documentation.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "alias", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${alias}", 3 );
                append( sb, "", 0 );

                append( sb, "arguments", 2 );
                append( sb, "List of additional arguments to append to the keytool command line.", 3 );
                append( sb, "Expression: ${keytool.arguments}", 3 );
                append( sb, "", 0 );

                append( sb, "dname", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${dname}", 3 );
                append( sb, "", 0 );

                append( sb, "keyalg", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${keyalg}", 3 );
                append( sb, "", 0 );

                append( sb, "keypass", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${keypass}", 3 );
                append( sb, "", 0 );

                append( sb, "keysize", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${keysize}", 3 );
                append( sb, "", 0 );

                append( sb, "keystore", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${keystore}", 3 );
                append( sb, "", 0 );

                append( sb, "sigalg", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${sigalg}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "storepass", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${storepass}", 3 );
                append( sb, "", 0 );

                append( sb, "storetype", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${storetype}", 3 );
                append( sb, "", 0 );

                append( sb, "validity", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${validity}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Enable verbose. See options.", 3 );
                append( sb, "Expression: ${verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory (Default: ${basedir})", 2 );
                append( sb, "Where to execute the keytool command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${keytool.workingdir}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "keytool:help", 0 );
            append( sb, "Display help information on keytool-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0keytool:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "Expression: ${detail}", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "Expression: ${goal}", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "Expression: ${indentSize}", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "Expression: ${lineLength}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "import".equals( goal ) )
        {
            append( sb, "keytool:import", 0 );
            append( sb, "Reads the certificate or certificate chain (where the latter is supplied in a PKCS#7 formatted reply) from the file cert_file, and stores it in the keystore entry identified by alias. Implemented as a wrapper around the SDK keytool -import command.\n-import\u00a0\u00a0\u00a0[-v]\u00a0[-protected]\n[-alias\u00a0<alias>]\n[-file\u00a0<file>]\n[-keypass\u00a0<keypass>]\n[-storepass\u00a0<storepass>]\n[-storetype\u00a0<storetype>]\n[-keystore\u00a0<keystore>]\nSee keystore documentation.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "alias", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${alias}", 3 );
                append( sb, "", 0 );

                append( sb, "arguments", 2 );
                append( sb, "List of additional arguments to append to the keytool command line.", 3 );
                append( sb, "Expression: ${keytool.arguments}", 3 );
                append( sb, "", 0 );

                append( sb, "file", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${file}", 3 );
                append( sb, "", 0 );

                append( sb, "keypass", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${keypass}", 3 );
                append( sb, "", 0 );

                append( sb, "keystore", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${keystore}", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set to true to disable the plugin.", 3 );
                append( sb, "Expression: ${keytool.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "storepass", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${storepass}", 3 );
                append( sb, "", 0 );

                append( sb, "storetype", 2 );
                append( sb, "See options.", 3 );
                append( sb, "Expression: ${storetype}", 3 );
                append( sb, "", 0 );

                append( sb, "useJREcacerts (Default: false)", 2 );
                append( sb, "Imports Cert in current Java Runtime lib/security/cacerts.", 3 );
                append( sb, "Expression: ${useJREcacerts}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Enable verbose. See options.", 3 );
                append( sb, "Expression: ${verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDirectory (Default: ${basedir})", 2 );
                append( sb, "Where to execute the keytool command.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${keytool.workingdir}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
